#include <bits/stdc++.h>

using namespace std;

const int MAXN = 10'000;
const int INFINIT = 1'000'000'000;
const unsigned int BASE = 31;

int dp[MAXN + 1], n;
unsigned int power[MAXN + 1], sp[MAXN + 1], rev_sp[MAXN + 1];

unsigned int getHash(int st, int dr) {
  return sp[dr] - power[dr - st] * sp[st];
}

unsigned int getRevHash(int st, int dr) {
  return rev_sp[n - st] - power[dr - st] * rev_sp[n - dr];
}

int palindrome(int st, int dr) {
  if(dr % 2 == st % 2) {
    return getHash(st, (st + dr) / 2) == getRevHash((st + dr) / 2, dr);
  }
  return getHash(st, (st + dr - 1) / 2) == getRevHash((st + dr + 1) / 2, dr);
}

int main() {
  ios_base::sync_with_stdio(0);
  cin.tie(0);

  string s;
  cin >> s;

  n = s.size();
  s = "#" + s;

  power[0] = 1;
  for(int i = 1; i <= n; i++) {
    power[i] = power[i - 1] * BASE;
  }

  for(int i = 1; i <= n; i++) {
    sp[i] = BASE * sp[i - 1] + (s[i] - 'a');
    rev_sp[i] = BASE * rev_sp[i - 1] + (s[n + 1 - i] - 'a');
  }

  for(int i = 1; i <= n; i++) {
    dp[i] = INFINIT;
    for(int j = 0; j < i; j++) {
      if(palindrome(j, i)) {
        dp[i] = min(dp[i], dp[j] + 1);
      }
    }
  }

  cout << dp[n] << "\n";
  return 0;
}