#include <bits/stdc++.h>
using namespace std;
using ll = long long;
const ll P = 228;
const ll M = 1e9 + 21;
const ll INF = 1e18 + 10;
const ll MAXN = 1e4 + 10;

bool is_prime(ll x) {
    for (ll i = 2; i * i <= x; i++) {
        if (x % i == 0) {
            return false;
        }
    }
    return true;
}

ll pw(ll x, ll n) {
    if (n == 0) return 1;
    if (n % 2) return (x * pw(x, n - 1)) % M;
    ll a = pw(x, n / 2); return (a * a) % M;
}

vector<ll> pp;
vector<ll> rp;
void prep() {
    rp.assign(MAXN, 1);
    pp.assign(MAXN, 1);
    for (ll i = 1; i < MAXN; i++) {
        pp[i] = (pp[i - 1] * P) % M;
        rp[i] = pw(pp[i], M - 2);
    }
}


void solve() {
    /*for (ll i = M + 1; ; i++) {
        if (is_prime(i)) {
            cout << i << '\n';
            return;
        }
    }*/
    string s;
    cin >> s;
    ll n = s.size();

    vector<ll> h1(n);
    for (ll i = 0; i < n; i++) {
        h1[i] = (s[i] * pp[i]) % M;
        if (i) {
            h1[i] = (h1[i] + h1[i - 1]) % M;
        }
    }

    vector<ll> h2(n);
    for (ll i = 0; i < n; i++) {
        h2[i] = (s[i] * pp[n - 1 - i]) % M;
        if (i) {
            h2[i] = (h2[i] + h2[i - 1]) % M;
        }
    }

    auto is_pal = [&](ll l, ll r) {
        ll x1 = h1[r];
        if (l) x1 -= h1[l - 1];
        x1 = (x1 % M + M) % M;
        x1 = (x1 * rp[l]) % M;

        ll x2 = h2[r];
        if (l) x2 -= h2[l - 1];
        x2 = (x2 % M + M) % M;
        x2 = (x2 * rp[n - 1 - r]) % M;

        return (x1 == x2);
    };

    vector<ll> dp(n, INF);
    for (ll i = 0; i < n; i++) {
        if (is_pal(0, i)) {
            dp[i] = 1;
        }
    }

    for (ll i = 1; i < n; i++) {
        for (ll j = 1; j <= i; j++) {
            if (is_pal(j, i)) {
                dp[i] = min(dp[i], dp[j - 1] + 1);
            }
        }
    }

    cout << dp[n - 1] << '\n';
}


int main() {
    prep();
    bool IS_MULTITEST = 0;
    #ifdef flam3
        freopen("ain.txt", "r", stdin);
        IS_MULTITEST = 1;
    #endif
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    ll t = 1;
    if (IS_MULTITEST) {
        cin >> t;
    }
    while (t--) {
        solve();
    }
}