#include <stdio.h>
#include <algorithm>

const int MAX_N = 10'000;
const int BASE = 29;
const int MOD = 1'000'000'007;
const int INF = 2'000'000'000;

int n;
char s[MAX_N];
int hash1[MAX_N + 2], hash2[MAX_N + 2];
int put[MAX_N + 1];
int iput[MAX_N + 1];
int dp[MAX_N + 1];

int lgput(int a, int b) {
  int ret = 1;
  while(b > 0) {
    if(b & 1) {
      ret = 1LL * ret * a % MOD;
    }
    a = 1LL * a * a % MOD;
    b /= 2;
  }
  return ret;
}

bool is_pal(int l, int r) {
  int h1 = (MOD + hash1[r] - hash1[l - 1]) % MOD;
  h1 = (1LL * h1 * iput[l - 1]) % MOD;
  int h2 = (MOD + hash2[l] - hash2[r + 1]) % MOD;
  h2 = (1LL * h2 * iput[n - r]) % MOD;
  return h1 == h2;
}

int main() {
  n = 0;
  char ch;
  while((ch = fgetc(stdin)) != '\n') {
    s[n++] = ch - 'a';
  }

  put[0] = 1;
  iput[0] = 1;
  for(int i = 1; i <= n; i++) {
    put[i] = (1LL * put[i - 1] * BASE) % MOD;
    iput[i] = lgput(put[i], MOD - 2);
  }

  for(int i = 1; i <= n; i++) {
    hash1[i] = (hash1[i - 1] + 1LL * s[i - 1] * put[i - 1]) % MOD;
  }
  for(int i = n; i >= 1; i--) {
    hash2[i] = (hash2[i + 1] + 1LL * s[i - 1] * put[n - i]) % MOD;
  }

  for(int i = 1; i <= n; i++) {
    dp[i] = INF;
  }

  for(int i = 1; i <= n; i++) {
    for(int j = 1; j <= i; j++) {
      if(is_pal(j, i)) {
        dp[i] = std::min(dp[i], dp[j - 1] + 1);
      }
    }
  }

  printf("%d\n", dp[n]);

  return 0;
}