#include <stdio.h>
#include <algorithm>

const int MAX_N = 10'000;
const int INF = 2'000'000'000;

int n;
char s[MAX_N];
std::vector<bool> is_pal[MAX_N + 1];
int dp[MAX_N + 1];


int main() {
  n = 0;
  char ch;
  while((ch = fgetc(stdin)) != '\n') {
    s[n++] = ch - 'a';
  }

  for(int i = 1; i <= n; i++) {
    is_pal[i].resize(n + 1);
    for(int j = 1; j <= n; j++) {
      is_pal[i][j] = 0;
    }
  }

  for(int mid = 1; mid <= n; mid++) {
    is_pal[mid][mid] = 1;
    int inc = 1;
    while(mid - inc >= 1 && mid + inc <= n &&
          s[mid - inc - 1] == s[mid + inc - 1]) {
      is_pal[mid - inc][mid + inc] = 1;
      inc++;
    }

    if(mid + 1 <= n && s[mid] == s[mid - 1]) {
      is_pal[mid][mid + 1] = 1;
      int inc = 1;
      while(mid - inc >= 1 && mid + inc + 1 <= n &&
            s[mid - inc - 1] == s[mid + inc]) {
        is_pal[mid - inc][mid + inc + 1] = 1;
        inc++;
      }
    }
  }

  for(int i = 1; i <= n; i++) {
    dp[i] = INF;
  }

  for(int i = 1; i <= n; i++) {
    for(int j = 1; j <= i; j++) {
      if(is_pal[j][i]) {
        dp[i] = std::min(dp[i], dp[j - 1] + 1);
      }
    }
  }

  printf("%d\n", dp[n]);

  return 0;
}